diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/libRTI/RTI1516ambassador.cpp origin/libRTI/RTI1516ambassador.cpp
--- patched/libRTI/RTI1516ambassador.cpp	2012-01-19 14:45:53.000000000 +0400
+++ origin/libRTI/RTI1516ambassador.cpp	2011-10-03 11:01:21.000000000 +0400
@@ -15,14 +15,6 @@
 
 #include <algorithm>
 
-#ifndef RTIA_USE_THREAD
-#define DEFINE_REQ_REP( MsgClass ) MsgClass local_req, *req = &local_req, local_rep, *rep = &local_rep
-#define DELETE_REP()
-#else
-#define DEFINE_REQ_REP( MsgClass ) MsgClass *req = new MsgClass, *rep = NULL
-#define DELETE_REP() delete rep
-#endif
-
 namespace {
 
 static PrettyDebug D("LIBRTI", __FILE__);
@@ -39,50 +31,53 @@
 	};
 
 	/* Helper functions */
-	template<typename MSG>
-	MSG* RTI1516ambassador::assignPHVMAndExecuteService(const rti1516::ParameterHandleValueMap &PHVM, MSG *req, MSG *rep ) {
+	template<typename T>
+	void
+	RTI1516ambassador::assignPHVMAndExecuteService(const rti1516::ParameterHandleValueMap &PHVM, T &req, T &rep) {
 
-		req->setParametersSize(PHVM.size());
-		req->setValuesSize(PHVM.size());
+		req.setParametersSize(PHVM.size());
+		req.setValuesSize(PHVM.size());
 		uint32_t i = 0;
 		for ( rti1516::ParameterHandleValueMap::const_iterator it = PHVM.begin(); it != PHVM.end(); it++, ++i)
 		{
-		    req->setParameters(ParameterHandleFriend::toCertiHandle(it->first),i);
+		    req.setParameters(ParameterHandleFriend::toCertiHandle(it->first),i);
 		    certi::ParameterValue_t paramValue;
 		    paramValue.resize(it->second.size());
 		    memcpy(&(paramValue[0]), it->second.data(), it->second.size());
-		    req->setValues(paramValue, i);
+		    req.setValues(paramValue, i);
 		}
-		return privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 	}
 
-	template<typename MSG>
-	MSG* RTI1516ambassador::assignAHVMAndExecuteService(const rti1516::AttributeHandleValueMap &AHVM, MSG *req, MSG *rep ) {
+	template<typename T>
+	void
+	RTI1516ambassador::assignAHVMAndExecuteService(const rti1516::AttributeHandleValueMap &AHVM, T &req, T &rep) {
 
-		req->setAttributesSize(AHVM.size());
-		req->setValuesSize(AHVM.size());
+		req.setAttributesSize(AHVM.size());
+		req.setValuesSize(AHVM.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleValueMap::const_iterator it = AHVM.begin(); it != AHVM.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(it->first),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(it->first),i);
  			certi::AttributeValue_t attrValue;
  			attrValue.resize(it->second.size());
  			memcpy(&(attrValue[0]), it->second.data(), it->second.size());
- 			req->setValues(attrValue, i);  
+ 			req.setValues(attrValue, i);  
 		}
-		return privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 	}
 
-	template<typename MSG>
-	MSG* RTI1516ambassador::assignAHSAndExecuteService(const rti1516::AttributeHandleSet &AHS, MSG *req, MSG *rep ) {
-		req->setAttributesSize(AHS.size());
+	template<typename T>
+	void
+	RTI1516ambassador::assignAHSAndExecuteService(const rti1516::AttributeHandleSet &AHS, T &req, T &rep) {
+		req.setAttributesSize(AHS.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = AHS.begin(); it != AHS.end(); it++, ++i)
 		{
 			certi::AttributeHandle certiHandle = AttributeHandleFriend::toCertiHandle(*it);
-			req->setAttributes(certiHandle,i);
+			req.setAttributes(certiHandle,i);
 		}
-		return privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 	}
 
 	std::string varLengthDataAsString(VariableLengthData varLengthData) {
@@ -120,11 +115,10 @@
 
 	RTI1516ambassador::~RTI1516ambassador()
 	{
-		DEFINE_REQ_REP( M_Close_Connexion );
+		certi::M_Close_Connexion req, rep ;
 
 		G.Out(pdGendoc,"        ====>executeService CLOSE_CONNEXION");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		// after the response is received, the privateRefs->socketUn must not be used
 
 		delete privateRefs;
@@ -140,74 +134,57 @@
 	throw (rti1516::SpecifiedSaveLabelDoesNotExist,
 			rti1516::RTIinternalError)
 	{
-		M_Tick_Request *vers_RTI = new M_Tick_Request;
-		Message* vers_Fed = NULL;
+		M_Tick_Request vers_RTI;
+		std::auto_ptr<Message> vers_Fed(NULL);
 
 		// Request callback(s) from the local RTIA
-		vers_RTI->setMultiple(multiple);
-		vers_RTI->setMinTickTime(minimum);
-		vers_RTI->setMaxTickTime(maximum);
+		vers_RTI.setMultiple(multiple);
+		vers_RTI.setMinTickTime(minimum);
+		vers_RTI.setMaxTickTime(maximum);
 
-#ifdef RTIA_USE_THREAD
-		bufSet.fed2amb.push( vers_RTI );
-#else // RTIA_USE_THREAD
 		try {
-			vers_RTI->send(privateRefs->socketUn,privateRefs->msgBufSend);
+			vers_RTI.send(privateRefs->socketUn,privateRefs->msgBufSend);
 		}
 		catch (NetworkError &e) {
-			delete vers_RTI;
 			std::stringstream msg;
 			msg << "NetworkError in tick() while sending TICK_REQUEST: " << e._reason;
 			std::wstring message(msg.str().begin(), msg.str().end());
 			throw RTIinternalError(message);
 		}
-		delete vers_RTI;
-#endif // RTIA_USE_THREAD
 
 		// Read response(s) from the local RTIA until Message::TICK_REQUEST is received.
 		while (1) {
-#ifdef RTIA_USE_THREAD
-			vers_Fed = bufSet.amb2fed.pull();
-#else // RTIA_USE_THREAD
 			try {
-				vers_Fed = M_Factory::receive(privateRefs->socketUn);
+				vers_Fed.reset(M_Factory::receive(privateRefs->socketUn));
 			}
 			catch (NetworkError &e) {
-				delete vers_Fed;
 				std::stringstream msg;
 				msg << "NetworkError in tick() while receiving response: " << e._reason;
 				std::wstring message(msg.str().begin(), msg.str().end());
 				throw RTIinternalError(message);
 			}
-#endif // RTIA_USE_THREAD
 
 			// If the type is TICK_REQUEST, the __tick_kernel() has terminated.
 			if (vers_Fed->getMessageType() == Message::TICK_REQUEST) {
 				if (vers_Fed->getExceptionType() != e_NO_EXCEPTION) {
 					// tick() may only throw exceptions defined in the HLA standard
 					// the RTIA is responsible for sending 'allowed' exceptions only
-					privateRefs->processException(vers_Fed);
+					privateRefs->processException(vers_Fed.get());
 				}
-				delete vers_Fed;
-				return static_cast<M_Tick_Request*>(vers_Fed)->getMultiple();
+				return static_cast<M_Tick_Request*>(vers_Fed.get())->getMultiple();
 			}
-			
+
 			try {
 				// Otherwise, the RTI calls a FederateAmbassador service.
-				privateRefs->callFederateAmbassador(vers_Fed);
+				privateRefs->callFederateAmbassador(vers_Fed.get());
 			}
-			catch (RTIinternalError) {
-				delete vers_Fed;
+			catch (RTIinternalError&) {
 				// RTIA awaits TICK_REQUEST_NEXT, terminate the tick() processing
 				privateRefs->sendTickRequestStop();
 				// ignore the response and re-throw the original exception
 				throw;
 			}
-			delete vers_Fed;
-			
-#ifdef RTIA_USE_THREAD
-			bufSet.fed2amb.push( new M_Tick_Request_Next );
-#else
+
 			try {
 				// Request next callback from the RTIA
 				M_Tick_Request_Next tick_next;
@@ -220,7 +197,6 @@
 				std::wstring message(msg.str().begin(), msg.str().end());
 				throw RTIinternalError(message);
 			}
-#endif // RTIA_USE_THREAD
 		} // while(1)
 	}
 
@@ -236,14 +212,14 @@
 		RTIinternalError)
 	{ 
 		/* TODO */
-		DEFINE_REQ_REP( M_Create_Federation_Execution );
+		certi::M_Create_Federation_Execution req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::createFederationExecution");
 		std::string federationExecutionNameAsString(federationExecutionName.begin(), federationExecutionName.end());
-		req->setFederationName(federationExecutionNameAsString);
+		req.setFederationName(federationExecutionNameAsString);
 		
 		std::string fullPathNameToTheFDDfileAsString(fullPathNameToTheFDDfile.begin(), fullPathNameToTheFDDfile.end());
-		req->setFEDid(fullPathNameToTheFDDfileAsString);
+		req.setFEDid(fullPathNameToTheFDDfileAsString);
 
 		/*#ifdef _WIN32
 		if(!stricmp(FED,executionName)) {
@@ -253,8 +229,7 @@
 		}*/
 		G.Out(pdGendoc,"             ====>executeService CREATE_FEDERATION_EXECUTION");
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit RTI1516ambassador::createFederationExecution");
 
@@ -270,17 +245,16 @@
 		FederationExecutionDoesNotExist,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Destroy_Federation_Execution );
+		M_Destroy_Federation_Execution req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::destroyFederationExecution");
 
 		std::string federationExecutionNameAsString(federationExecutionName.begin(), federationExecutionName.end());
-		req->setFederationName(federationExecutionNameAsString);
+		req.setFederationName(federationExecutionNameAsString);
 
 		G.Out(pdGendoc,"        ====>executeService DESTROY_FEDERATION_EXECUTION");
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit RTI1516ambassador::destroyFederationExecution");
 	}
@@ -297,7 +271,7 @@
 		CouldNotCreateLogicalTimeFactory,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Join_Federation_Execution );
+		M_Join_Federation_Execution req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::joinFederationExecution");
 
@@ -312,17 +286,16 @@
 
 		privateRefs->fed_amb = &federateAmbassador ;
 
-		req->setFederateName(federateTypeAsString);
-		req->setFederationName(federationExecutionNameAsString);
+		req.setFederateName(federateTypeAsString);
+		req.setFederationName(federationExecutionNameAsString);
 		G.Out(pdGendoc,"        ====>executeService JOIN_FEDERATION_EXECUTION");
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::joinFederationExecution");
 		PrettyDebug::setFederateName( "LibRTI::"+std::string(federateTypeAsString));
 		
-		certi::FederateHandle certiFederateHandle = rep->getFederate();
+		certi::FederateHandle certiFederateHandle = rep.getFederate();
 		rti1516::FederateHandle rti1516FederateHandle = rti1516::FederateHandleFriend::createRTI1516Handle(certiFederateHandle);
 
-		DELETE_REP();
 		return rti1516FederateHandle;
 	}
 
@@ -334,14 +307,13 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Resign_Federation_Execution );
+		M_Resign_Federation_Execution req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::resignFederationExecution");
-		//req->setResignAction(static_cast<certi::ResignAction>(resignAction));
-		req->setResignAction(certi::DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
+		//req.setResignAction(static_cast<certi::ResignAction>(resignAction));
+		req.setResignAction(certi::DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
 		G.Out(pdGendoc,"        ====>executeService RESIGN_FEDERATION_EXECUTION");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit RTI1516ambassador::resignFederationExecution");
 	}
 
@@ -354,21 +326,20 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Register_Federation_Synchronization_Point );
+		M_Register_Federation_Synchronization_Point req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::registerFederationSynchronizationPoint for all federates");
 		std::string labelString(label.begin(), label.end());
-		req->setLabel(labelString);
+		req.setLabel(labelString);
 		// no federate set
-		req->setFederateSetSize(0);
+		req.setFederateSetSize(0);
 		if ( &theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL )
 		{
 			throw RTIinternalError (L"Calling registerFederationSynchronizationPoint with Tag NULL");
 		}
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
 		G.Out(pdGendoc,"        ====>executeService REGISTER_FEDERATION_SYNCHRONIZATION_POINT");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit RTI1516ambassador::registerFederationSynchronizationPoint for all federates");
 	}
@@ -382,32 +353,31 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Register_Federation_Synchronization_Point );
+		M_Register_Federation_Synchronization_Point req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::registerFederationSynchronizationPoint for some federates");
 
 		std::string labelString(label.begin(), label.end());
-		req->setLabel(labelString);
+		req.setLabel(labelString);
 		if ( &theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL )
 		{
 			throw RTIinternalError (L"Calling registerFederationSynchronizationPoint with Tag NULL");
 		}
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
 		// Federate set exists but if size=0 (set empty)
 		// We have to send the size even if federate set size is 0
 		// (HLA 1.3 compliance to inform ALL federates)
 
-		req->setFederateSetSize(syncSet.size());
+		req.setFederateSetSize(syncSet.size());
 
 		uint32_t i = 0;
 		for ( rti1516::FederateHandleSet::const_iterator it = syncSet.begin(); it != syncSet.end(); it++, ++i)
 		{
-			req->setFederateSet(FederateHandleFriend::toCertiHandle(*it),i); 
+			req.setFederateSet(FederateHandleFriend::toCertiHandle(*it),i); 
 		}
 
 		G.Out(pdGendoc,"        ====>executeService REGISTER_FEDERATION_SYNCHRONIZATION_POINT");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit RTI1516ambassador::registerFederationSynchronizationPoint for some federates");
 	}
@@ -421,16 +391,15 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Synchronization_Point_Achieved );
+		M_Synchronization_Point_Achieved req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::synchronizationPointAchieved");
 
 		std::string labelString(label.begin(), label.end());
-		req->setLabel(labelString);
+		req.setLabel(labelString);
 
 		G.Out(pdGendoc,"        ====>executeService SYNCHRONIZATION_POINT_ACHIEVED");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit  RTI1516ambassador::synchronizationPointAchieved"); 
 	}
@@ -443,16 +412,15 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Request_Federation_Save );
+		M_Request_Federation_Save req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::requestFederationSave without time");
 
 		std::string labelString(label.begin(), label.end());
-		req->setLabel(labelString);
+		req.setLabel(labelString);
 		G.Out(pdGendoc,"      ====>executeService REQUEST_FEDERATION_SAVE");
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::requestFederationSave without time");
 	}
 
@@ -467,19 +435,18 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Request_Federation_Save );
+		M_Request_Federation_Save req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::requestFederationSave with time");
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
 		std::string labelString(label.begin(), label.end());
-		req->setLabel(labelString);
+		req.setLabel(labelString);
 
 		G.Out(pdGendoc,"        ====>executeService REQUEST_FEDERATION_SAVE");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit RTI1516ambassador::requestFederationSave with time");
 	}
@@ -491,13 +458,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Federate_Save_Begun );
+		M_Federate_Save_Begun req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::federateSaveBegun");
 
 		G.Out(pdGendoc,"      ====>executeService FEDERATE_SAVE_BEGUN");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit  RTI1516ambassador::federateSaveBegun");
 	}
@@ -509,12 +475,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Federate_Save_Complete );
+		M_Federate_Save_Complete req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::federateSaveComplete");
 		G.Out(pdGendoc,"      ====>executeService FEDERATE_SAVE_COMPLETE");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::federateSaveComplete");
 	}
 
@@ -524,12 +489,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Federate_Save_Not_Complete );
+		M_Federate_Save_Not_Complete req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::federateSaveNotComplete");
 		G.Out(pdGendoc,"      ====>executeService FEDERATE_SAVE_NOT_COMPLETE");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit  RTI1516ambassador::federateSaveNotComplete");
 	}
@@ -552,14 +516,13 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Request_Federation_Restore );
+		M_Request_Federation_Restore req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::requestFederationRestore");
 		std::string labelString(label.begin(), label.end());
-		req->setLabel(labelString);
+		req.setLabel(labelString);
 		G.Out(pdGendoc,"      ====>executeService REQUEST_FEDERATION_RESTORE");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::requestFederationRestore");
 	}
 
@@ -570,13 +533,12 @@
 		SaveInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Federate_Restore_Complete );
+		M_Federate_Restore_Complete req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::federateRestoreComplete");
 
 		G.Out(pdGendoc,"      ====>executeService FEDERATE_RESTORE_COMPLETE");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::federateRestoreComplete");
 	}
 
@@ -586,13 +548,12 @@
 		SaveInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Federate_Restore_Not_Complete );
+		M_Federate_Restore_Not_Complete req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::federateRestoreNotComplete");
 		G.Out(pdGendoc,"      ====>executeService FEDERATE_RESTORE_NOT_COMPLETE");
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::federateRestoreNotComplete");
 	}
 
@@ -621,21 +582,20 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Publish_Object_Class );
+		M_Publish_Object_Class req, rep ;
 		G.Out(pdGendoc,"enter RTI1516ambassador::publishObjectClass");
 
 		const certi::ObjectClassHandle objectClassHandle =  ObjectClassHandleFriend::toCertiHandle(theClass);
-		req->setObjectClass(objectClassHandle);
+		req.setObjectClass(objectClassHandle);
 
-		req->setAttributesSize(attributeList.size());
+		req.setAttributesSize(attributeList.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = attributeList.begin(); it != attributeList.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
 		}
 		G.Out(pdGendoc,"      ====>executeService PUBLISH_OBJECT_CLASS");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::publishObjectClass");
 	}
 
@@ -649,14 +609,13 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Unpublish_Object_Class );
+		M_Unpublish_Object_Class req, rep ;
 		G.Out(pdGendoc,"enter RTI1516ambassador::unpublishObjectClass");
 
 		const certi::ObjectClassHandle objectClassHandle = ObjectClassHandleFriend::toCertiHandle(theClass);
-		req->setObjectClass(objectClassHandle);
+		req.setObjectClass(objectClassHandle);
 		G.Out(pdGendoc,"      ====>executeService UNPUBLISH_OBJECT_CLASS");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::unpublishObjectClass");
 	}
 
@@ -684,12 +643,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Publish_Interaction_Class );
+		M_Publish_Interaction_Class req, rep ;
 		const certi::InteractionClassHandle classHandle = InteractionClassHandleFriend::toCertiHandle(theInteraction);
-		req->setInteractionClass(classHandle);
+		req.setInteractionClass(classHandle);
 		G.Out(pdGendoc,"      ====>executeService PUBLISH_INTERACTION_CLASS");
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 5.5
@@ -701,12 +659,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Unpublish_Interaction_Class );
+		M_Unpublish_Interaction_Class req, rep ;
 		const certi::InteractionClassHandle classHandle = InteractionClassHandleFriend::toCertiHandle(theInteraction);
-		req->setInteractionClass(classHandle);
+		req.setInteractionClass(classHandle);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 5.6
@@ -721,22 +678,21 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Subscribe_Object_Class_Attributes );
+		M_Subscribe_Object_Class_Attributes req, rep ;
 		G.Out(pdGendoc,"enter RTI1516ambassador::subscribeObjectClassAttributes");
 
 		const certi::ObjectClassHandle objectClassHandle = ObjectClassHandleFriend::toCertiHandle(theClass);
-		req->setObjectClass(objectClassHandle);
+		req.setObjectClass(objectClassHandle);
 
-		req->setAttributesSize(attributeList.size());
+		req.setAttributesSize(attributeList.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = attributeList.begin(); it != attributeList.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
 		}
-		req->setActive(active);
+		req.setActive(active);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::subscribeObjectClassAttributes");
 	}
 
@@ -749,13 +705,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Unsubscribe_Object_Class );
+		M_Unsubscribe_Object_Class req, rep ;
 
 		const certi::ObjectClassHandle objectClassHandle = ObjectClassHandleFriend::toCertiHandle(theClass);
-		req->setObjectClass(objectClassHandle);
+		req.setObjectClass(objectClassHandle);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP(); 
+		privateRefs->executeService(&req, &rep); 
 	}
 
 	void RTI1516ambassador::unsubscribeObjectClassAttributes
@@ -783,12 +738,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Subscribe_Interaction_Class );
+		M_Subscribe_Interaction_Class req, rep ;
 		const certi::InteractionClassHandle classHandle = InteractionClassHandleFriend::toCertiHandle(theClass);
-		req->setInteractionClass(classHandle);
+		req.setInteractionClass(classHandle);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 5.9
@@ -800,13 +754,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Unsubscribe_Interaction_Class );
+		M_Unsubscribe_Interaction_Class req, rep ;
 
 		const certi::InteractionClassHandle classHandle = InteractionClassHandleFriend::toCertiHandle(theClass);
-		req->setInteractionClass(classHandle);
+		req.setInteractionClass(classHandle);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	////////////////////////////////
@@ -822,12 +775,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Reserve_Object_Instance_Name );
+		M_Reserve_Object_Instance_Name req, rep;
 
 		std::string objInstanceName(theObjectInstanceName.begin(), theObjectInstanceName.end());
-		req->setObjectName(objInstanceName);
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		req.setObjectName(objInstanceName);
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 6.4
@@ -840,13 +792,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Register_Object_Instance );
+		M_Register_Object_Instance req, rep ;
 
-		req->setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		ObjectInstanceHandle handle = rti1516::ObjectInstanceHandleFriend::createRTI1516Handle(rep->getObject());
-		DELETE_REP();
-		return handle;
+		req.setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
+		privateRefs->executeService(&req, &rep);
+		return rti1516::ObjectInstanceHandleFriend::createRTI1516Handle(rep.getObject());
 	}
 
 	ObjectInstanceHandle RTI1516ambassador::registerObjectInstance
@@ -861,15 +811,14 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Register_Object_Instance );
+		M_Register_Object_Instance req, rep ;
 
 		std::string nameString(theObjectInstanceName.begin(), theObjectInstanceName.end());
-		req->setObjectName(nameString);
-		req->setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		ObjectInstanceHandle handle = rti1516::ObjectInstanceHandleFriend::createRTI1516Handle(rep->getObject());
-		DELETE_REP();
-		return handle;
+		req.setObjectName(nameString);
+		req.setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
+		privateRefs->executeService(&req, &rep);
+
+		return rti1516::ObjectInstanceHandleFriend::createRTI1516Handle(rep.getObject());
 	}
 
 	// 6.6
@@ -886,17 +835,17 @@
 		RTIinternalError)
 	{ 
 		G.Out(pdGendoc,"enter RTI1516ambassador::updateAttributeValues without time");
-		DEFINE_REQ_REP( M_Update_Attribute_Values );
+		M_Update_Attribute_Values req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		if ( &theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL)
 		{
 			throw RTIinternalError(L"Calling updateAttributeValues with Tag NULL");
 		}
 
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
 
-		rep = assignAHVMAndExecuteService(theAttributeValues, req, rep );
+		assignAHVMAndExecuteService(theAttributeValues, req, rep);
 
 		G.Out(pdGendoc,"exit  RTI1516ambassador::updateAttributeValues without time");
 	}
@@ -916,25 +865,25 @@
 		RTIinternalError)
 	{ 
 		G.Out(pdGendoc,"enter RTI1516ambassador::updateAttributeValues with time");
-		DEFINE_REQ_REP( M_Update_Attribute_Values );
+		M_Update_Attribute_Values req, rep ;
 		
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
 		if ( &theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL)
 		{
 			throw RTIinternalError(L"Calling updateAttributeValues with Tag NULL");
 		}
 
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
 		
-		rep = assignAHVMAndExecuteService(theAttributeValues, req, rep );
+		assignAHVMAndExecuteService(theAttributeValues, req, rep);
 
 		G.Out(pdGendoc,"return  RTI1516ambassador::updateAttributeValues with time");
-		certi::FederateHandle certiHandle = rep->getEventRetraction().getSendingFederate();
-		uint64_t serialNum = rep->getEventRetraction().getSN();
+		certi::FederateHandle certiHandle = rep.getEventRetraction().getSendingFederate();
+		uint64_t serialNum = rep.getEventRetraction().getSN();
 		return rti1516::MessageRetractionHandleFriend::createRTI1516Handle(certiHandle, serialNum);
 	}
 
@@ -951,20 +900,20 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Send_Interaction );
+		M_Send_Interaction req, rep ;
 
 		const certi::InteractionClassHandle classHandle = InteractionClassHandleFriend::toCertiHandle(theInteraction);
-		req->setInteractionClass(classHandle);
+		req.setInteractionClass(classHandle);
 
 		if (&theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL )
 		{
 			throw RTIinternalError (L"Calling sendIntercation with Tag NULL") ;
 		}
 
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
-		req->setRegion(0);
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setRegion(0);
 		
-		rep = assignPHVMAndExecuteService(theParameterValues, req, rep );
+		assignPHVMAndExecuteService(theParameterValues, req, rep);
 	}
 
 	MessageRetractionHandle RTI1516ambassador::sendInteraction
@@ -981,25 +930,25 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Send_Interaction );
+		M_Send_Interaction req, rep ;
 
 		const certi::InteractionClassHandle classHandle = InteractionClassHandleFriend::toCertiHandle(theInteraction);
-		req->setInteractionClass(classHandle);
+		req.setInteractionClass(classHandle);
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
 		if (&theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL ) {
 			throw RTIinternalError(L"Calling sendInteraction with Tag NULL") ;
 		}
 
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
-		req->setRegion(0);
-		
-		rep = assignPHVMAndExecuteService(theParameterValues, req, rep );
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setRegion(0);
 		
-		certi::FederateHandle certiHandle = rep->getEventRetraction().getSendingFederate();
-		uint64_t serialNr = rep->getEventRetraction().getSN();
+		assignPHVMAndExecuteService(theParameterValues, req, rep);
+
+		certi::FederateHandle certiHandle = rep.getEventRetraction().getSendingFederate();
+		uint64_t serialNr = rep.getEventRetraction().getSN();
 		rti1516::MessageRetractionHandle rti1516handle = MessageRetractionHandleFriend::createRTI1516Handle(certiHandle, serialNr);
 		
 		return rti1516handle;
@@ -1016,18 +965,17 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Delete_Object_Instance );
+		M_Delete_Object_Instance req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		if ( &theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL)
 		{
 			throw RTIinternalError(L"Calling deleteObjectInstance with Tag NULL") ;
 		}
 
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	MessageRetractionHandle RTI1516ambassador::deleteObjectInstance
